# ValidatorRewardPool

## Contents

## Globals

| Var       | Type                        |
| --------- | --------------------------- |
| balanceOf | mapping(address => uint256) |

## Functions

### constructor

No description

**Declaration:**

```solidity
  function constructor(
  ) public Only
```

**Modifiers:**

| Modifier |
| -------- |
| Only     |

### claim

Claim validator reward.

**Declaration:**

```solidity
  function claim(
    address validator,
    uint256 amount
  ) external nonReentrant onlyStakeManager
```

**Modifiers:**

| Modifier         |
| ---------------- |
| nonReentrant     |
| onlyStakeManager |

**Args:**

| Arg         | Type    | Description        |
| ----------- | ------- | ------------------ |
| `validator` | address | Validator address. |
| `amount`    | uint256 | Claim amount.      |

### reward

Reward validator.

**Declaration:**

```solidity
  function reward(
    address validator
  ) external nonReentrant onlyStakeManager
```

**Modifiers:**

| Modifier         |
| ---------------- |
| nonReentrant     |
| onlyStakeManager |

**Args:**

| Arg         | Type    | Description        |
| ----------- | ------- | ------------------ |
| `validator` | address | Validator address. |

### slash

Slash validator and transfer the slashed amount to `address(0)`.

**Declaration:**

```solidity
  function slash(
    address validator,
    uint8 factor
  ) external nonReentrant onlyStakeManager returns (uint256 amount)
```

**Modifiers:**

| Modifier         |
| ---------------- |
| nonReentrant     |
| onlyStakeManager |

**Args:**

| Arg         | Type    | Description        |
| ----------- | ------- | ------------------ |
| `validator` | address | Validator address. |
| `factor`    | uint8   | Slash factor.      |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.rei.network/developer/system-contracts/validatorrewardpool.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
